/*
  see here for original idea
  http://www.codeproject.com/KB/threads/MinimalisticRingZero.aspx
 */
 
 #define _WIN32_WINNT 0x0500
 #include <windows.h>
 #include <aclapi.h>
 #include <winternl.h>
 #include <stdio.h>
 
#define DECLARE_CONST_UNICODE_STRING(_var, _string) \
const WCHAR _var ## _buffer[] = _string; \
const UNICODE_STRING _var = { sizeof(_string) - sizeof(WCHAR), sizeof(_string), (PWCH) _var ## _buffer }
 
enum GDT_INDEX {
	KGDT_NULL,
	KGDT_R0_CODE,
	KGDT_R0_DATA,
	KGDT_R3_CODE,
	KGDT_R3_DATA
};

enum DESC_TBL {
	GLOBAL_DESC_TBL,
	LOCAL_DESC_TBL
};

enum PRIVLEDGE_LEVEL {
	RING_0, RING_1, RING_2, RING_3
};

#pragma pack(push, 1)
typedef struct tagGDTR {
	WORD limit;
	DWORD base;
} GDTR, *PGDTR;

typedef GDTR IDTR, *PIDTR;
typedef WORD TSSR, *PTSSR;

struct CALL_GATE_DESC {
	WORD addrlo;
	WORD seg;
	BYTE args   : 5;
	BYTE zerome : 3;
	BYTE type   : 5;
	BYTE dpl    : 2;
	BYTE pres   : 1;
	WORD addrhi;
};

typedef struct tagINT_GATE_DESC {
	WORD addrlo;
	WORD seg;
	BYTE reserv : 5;
	BYTE zerome : 3;
	BYTE type   : 5;
	BYTE dpl    : 2;
	BYTE pres   : 1;
	WORD addrhi;
} INT_GATE_DESC, *PINT_GATE_DESC;

typedef struct tagTSS_GATE_DESC {
	WORD reserved1;
	WORD tss_seg;
	BYTE reserved2;
	BYTE type   : 5;
	BYTE dpl    : 2;
	BYTE pres   : 1;
	WORD reserved3;
} TSS_GATE_DESC, *PTSS_GATE_DESC;

typedef struct tagSTAR {
	DWORD eip;
	WORD  call_cs;
	WORD  ret_cs;
} STAR, *PSTAR;

#pragma pack(pop)

#define SEG_SELECTOR(index, table, pl) ((index<<3)|(table<<2)|pl)
#define R0_CODE_SEG SEG_SELECTOR(KGDT_R0_CODE, GLOBAL_DESC_TBL, RING_0)

typedef LONG NTSTATUS;
#define NT_SUCCESS(Status) ((NTSTATUS)(Status) >= 0)
#define STATUS_INFO_LENGTH_MISMATCH      ((NTSTATUS)0xC0000004L)

typedef enum _SECTION_INHERIT {
	ViewShare=1, ViewUnmap=2
} SECTION_INHERIT, *PSECTION_INHERIT;

typedef LARGE_INTEGER PHYSICAL_ADDRESS, *PPHYSICAL_ADDRESS;

typedef struct _RTL_PROCESS_MODULE_INFORMATION
{
    ULONG Section;
    PVOID MappedBase;
    PVOID ImageBase;
    ULONG ImageSize;
    ULONG Flags;
    USHORT LoadOrderIndex;
    USHORT InitOrderIndex;
    USHORT LoadCount;
    USHORT OffsetToFileName;
    CHAR FullPathName[256];
} RTL_PROCESS_MODULE_INFORMATION, *PRTL_PROCESS_MODULE_INFORMATION;

#define SystemModuleInformation 11

typedef struct _RTL_PROCESS_MODULES
{
    ULONG NumberOfModules;
    RTL_PROCESS_MODULE_INFORMATION Modules[1];
} RTL_PROCESS_MODULES, *PRTL_PROCESS_MODULES;

typedef ULONG_PTR KAFFINITY;
typedef LONG KPRIORITY;
typedef struct _CLIENT_ID {
	HANDLE  UniqueProcess;
	HANDLE  UniqueThread;
} CLIENT_ID, *PCLIENT_ID;

typedef struct _THREAD_BASIC_INFORMATION {
	NTSTATUS ExitStatus;
	PVOID TebBaseAddress;
	CLIENT_ID ClientId;
	KAFFINITY AffinityMask;
	KPRIORITY Priority;
	KPRIORITY BasePriority;
} THREAD_BASIC_INFORMATION, *PTHREAD_BASIC_INFORMATION;

typedef enum _THREAD_INFORMATION_CLASS {
	ThreadBasicInformation,
	ThreadTimes,
	ThreadPriority,
	ThreadBasePriority,
	ThreadAffinityMask
} THREAD_INFORMATION_CLASS, *PTHREAD_INFORMATION_CLASS;

NTSTATUS NTAPI NtOpenSection(PHANDLE SectionHandle, ACCESS_MASK DesiredAccess, POBJECT_ATTRIBUTES ObjectAttributes ); 
NTSTATUS NTAPI NtMapViewOfSection(HANDLE SectionHandle, HANDLE ProcessHandle, PVOID *BaseAddress, ULONG ZeroBits, ULONG CommitSize, PLARGE_INTEGER SectionOffset, PULONG ViewSize, int InheritDisposition, ULONG AllocationType, ULONG Protect ); 
NTSTATUS NTAPI NtUnmapViewOfSection(HANDLE ProcessHandle, PVOID BaseAddress ); 
NTSTATUS (NTAPI *_NtQuerySystemInformation) (SYSTEM_INFORMATION_CLASS SystemInformationClass, PVOID SystemInformation, ULONG SystemInformationLength, PULONG ReturnLength); 

void GetIDTR(PIDTR idtr) {
	DWORD buffer[2];
	__asm {
		lea eax, buffer
		or eax, 2
		sidt [eax]
	}
	*idtr = *(PGDTR)(((DWORD)buffer) | 2);
}

void GetGDTR(PGDTR gdtr) {
	DWORD buffer[2];
	__asm {
		lea eax, buffer
		or eax, 2
		sgdt [eax]
	}
	*gdtr = *(PGDTR)(((DWORD)buffer) | 2);
}

TSSR GetTSSR() {
	TSSR tr;
	__asm str tr
	return tr;
}

PLDT_ENTRY GlobalDescTbl;
DWORD      MappedSize;
HANDLE     PhysicalMemorySection;

HANDLE GetPhysicalMemorySection() {
	NTSTATUS status;
	EXPLICIT_ACCESS Access;
	PVOID security;
	HANDLE Section; 
	PACL OldDacl=NULL, NewDacl=NULL;
	DECLARE_CONST_UNICODE_STRING(name, L"\\Device\\PhysicalMemory");
	OBJECT_ATTRIBUTES oa ={sizeof(oa),0,&name,0,0,0};  

	memset(&Access, 0, sizeof(EXPLICIT_ACCESS));
	
	status = NtOpenSection(&Section, WRITE_DAC | READ_CONTROL, &oa);
	if(!NT_SUCCESS(status)) return NULL;
   
	if(GetSecurityInfo(Section, SE_KERNEL_OBJECT, 
                         DACL_SECURITY_INFORMATION, 
                         NULL, NULL, &OldDacl,
                         NULL, &security) != ERROR_SUCCESS) {
		CloseHandle(Section);
		return NULL;
	}
   
	Access.grfAccessPermissions = SECTION_ALL_ACCESS; 
	Access.grfAccessMode        = GRANT_ACCESS;
	Access.grfInheritance       = NO_INHERITANCE;
	Access.Trustee.MultipleTrusteeOperation = NO_MULTIPLE_TRUSTEE;
	Access.Trustee.TrusteeForm  = TRUSTEE_IS_NAME;
	Access.Trustee.TrusteeType  = TRUSTEE_IS_USER;
	Access.Trustee.ptstrName = "CURRENT_USER";
  
	if(SetEntriesInAcl(1, &Access, OldDacl, &NewDacl) != ERROR_SUCCESS) {
		CloseHandle(Section);
		return NULL;
	}
	
	if(SetSecurityInfo(Section, SE_KERNEL_OBJECT,
                         DACL_SECURITY_INFORMATION, 
                         NULL, NULL, NewDacl, 
                         NULL) != ERROR_SUCCESS) {
		CloseHandle(Section);
		return NULL;
	}
	
	CloseHandle(Section);
	
	status = NtOpenSection(&Section, SECTION_MAP_READ|SECTION_MAP_WRITE, &oa);
	if(!NT_SUCCESS(status)) return NULL;
	
	return Section;
}

void call_gate_create_desc(struct CALL_GATE_DESC *gate, PVOID eip, WORD cs, WORD pl, WORD params) {
	gate->addrlo = ((DWORD)eip)&0xffff;
	gate->seg = cs;
	gate->args = params;
	gate->zerome = 0;
	gate->type = 0xC;
	gate->dpl = pl;
	gate->pres = 1;
	gate->addrhi = ((DWORD)eip)>>16;
}

DWORD __cdecl call_gate_call(WORD selector, DWORD param1, DWORD param2, DWORD param3, DWORD param4) {
	DWORD _ret;
	WORD farcall[3];
	farcall[2] = selector;
	__asm push param4
	__asm push param3
	__asm push param2
	__asm push param1
	__asm call fword ptr [farcall]
	__asm mov _ret, eax
	return _ret;
}

#define RING0ENTRY_PARAMS 4
__declspec(naked) DWORD Ring0Entry(DWORD cs, PVOID proc, DWORD param1, DWORD param2, DWORD param3, DWORD esp, DWORD ss) {
	__asm call proc
	__asm retf RING0ENTRY_PARAMS*4
}

typedef DWORD (__cdecl *Ring0Proc_t) (DWORD eip, DWORD cs, PVOID this_proc, DWORD param1, DWORD param2, DWORD param3, DWORD esp, DWORD ss);
DWORD __cdecl call_proc_in_ring0(DWORD entry, Ring0Proc_t proc, DWORD param1, DWORD param2, DWORD param3) {
	return call_gate_call(SEG_SELECTOR(entry, GLOBAL_DESC_TBL, RING_3), proc, param1, param2, param3);
}

DWORD __cdecl call_gate_install(struct CALL_GATE_DESC *call_gate) {
	DWORD i;
	for(i = 1; i < MappedSize / sizeof(LDT_ENTRY); i++) {
		if(!GlobalDescTbl[i].HighWord.Bits.Pres) {
			GlobalDescTbl[i] = *(PLDT_ENTRY)call_gate;
			return i;
		}
	}
	return 0;
}

void __cdecl call_gate_remove(DWORD entry) {
	memset(&GlobalDescTbl[entry], 0, sizeof(LDT_ENTRY));
}

BOOL __cdecl call_gate_init() {
	PHYSICAL_ADDRESS phys;
	NTSTATUS status;
	GDTR gdtr;
	
	GetGDTR(&gdtr);
	
	phys.QuadPart = gdtr.base & ~0x80000000;
	MappedSize    = gdtr.limit;
	printf("GDT @ 0x%08X limit = 0x%08X\n", gdtr.base, gdtr.limit);
	
	PhysicalMemorySection = GetPhysicalMemorySection();
	if(PhysicalMemorySection == NULL) return FALSE;
	
	GlobalDescTbl = NULL;
	status = NtMapViewOfSection(PhysicalMemorySection, (HANDLE) -1, 
              &GlobalDescTbl, 0L, MappedSize,
              &phys, &MappedSize, ViewShare, 0, 
              PAGE_READWRITE);
			  
	return NT_SUCCESS(status) ? TRUE : FALSE;
}

void __cdecl call_gate_free() {
	NtUnmapViewOfSection((HANDLE) -1, GlobalDescTbl);
	CloseHandle(PhysicalMemorySection);
}

//http://alter.org.ua/en/docs/nt_kernel/procaddr/#KernelGetProcAddress
PVOID KernelGetProcAddress(PVOID ModuleBase, PCHAR pFunctionName) {
    PVOID pFunctionAddress = NULL;
    
    __try
    {
	
        PIMAGE_DOS_HEADER dos =(PIMAGE_DOS_HEADER) ModuleBase;
        PIMAGE_NT_HEADERS nt  =(PIMAGE_NT_HEADERS)((ULONG) ModuleBase + dos->e_lfanew);

        PIMAGE_DATA_DIRECTORY expdir = (PIMAGE_DATA_DIRECTORY)
                                (nt->OptionalHeader.DataDirectory + IMAGE_DIRECTORY_ENTRY_EXPORT);
        ULONG                 addr = expdir->VirtualAddress;
		ULONG                 size = expdir->Size;
        PIMAGE_EXPORT_DIRECTORY exports =(PIMAGE_EXPORT_DIRECTORY)((ULONG) ModuleBase + addr);

        PULONG functions =(PULONG)((ULONG) ModuleBase + exports->AddressOfFunctions);
        PSHORT ordinals  =(PSHORT)((ULONG) ModuleBase + exports->AddressOfNameOrdinals);
        PULONG names     =(PULONG)((ULONG) ModuleBase + exports->AddressOfNames);
        ULONG  max_name  =exports->NumberOfNames;
        ULONG  max_func  =exports->NumberOfFunctions;

        ULONG i;

        for (i = 0; i < max_name; i++)
        {
            ULONG ord = ordinals[i];
            if(i >= max_name || ord >= max_func) {
                return NULL;
            }
            if (functions[ord] < addr || functions[ord] >= addr + size)
            {
                if (strcmp((PCHAR) ModuleBase + names[i], pFunctionName)  == 0)
                {
                    pFunctionAddress =(PVOID)((PCHAR) ModuleBase + functions[ord]);
                    break;
                }
            }
        }
   
    }
    __except(EXCEPTION_EXECUTE_HANDLER)
    {
        pFunctionAddress = NULL;
    }

    return pFunctionAddress;
} // end KernelGetProcAddress()


//KMODE functions
NTSTATUS (NTAPI *K_NtSetInformationThread) (HANDLE ThreadHandle, DWORD ThreadInformationClass, PVOID ThreadInformation, ULONG ThreadInformationLength); 
VOID (NTAPI *KeSetSystemAffinityThread) (KAFFINITY  Affinity);
PVOID (__stdcall *MmGetVirtualForPhysical) (PHYSICAL_ADDRESS PhysicalAddress);
NTSTATUS (__stdcall *PsLookupProcessByProcessId) (HANDLE ProcessId, PVOID *Process);
VOID  (__stdcall *ExFreePool) (PVOID  P);
PHYSICAL_ADDRESS (__stdcall *MmGetPhysicalAddress) (PVOID  BaseAddress);
PVOID (__stdcall *ExAllocatePool) (DWORD  PoolType, SIZE_T  NumberOfBytes);
DWORD (__stdcall *KeGetCurrentIrql) (VOID);

DWORD __cdecl Resolve_KMODE_funcs (DWORD eip, DWORD cs, PVOID this_proc, DWORD ntoskrnl, DWORD hal, DWORD param3, DWORD esp, DWORD ss) {
	K_NtSetInformationThread = KernelGetProcAddress(ntoskrnl, "NtSetInformationThread");
	KeSetSystemAffinityThread = KernelGetProcAddress(ntoskrnl, "KeSetSystemAffinityThread");
	KeGetCurrentIrql = KernelGetProcAddress(hal, "KeGetCurrentIrql");
	MmGetVirtualForPhysical = KernelGetProcAddress(ntoskrnl, "MmGetVirtualForPhysical");
	PsLookupProcessByProcessId = KernelGetProcAddress(ntoskrnl, "PsLookupProcessByProcessId");
	ExFreePool = KernelGetProcAddress(ntoskrnl, "ExFreePool");
	MmGetPhysicalAddress = KernelGetProcAddress(ntoskrnl, "MmGetPhysicalAddress");
	ExAllocatePool = KernelGetProcAddress(ntoskrnl, "ExAllocatePool");
	return 
		K_NtSetInformationThread && KeSetSystemAffinityThread &&
		KeGetCurrentIrql &&
		MmGetVirtualForPhysical && PsLookupProcessByProcessId && 
		ExFreePool && MmGetPhysicalAddress && ExAllocatePool ?
			TRUE : FALSE;
}

DWORD __cdecl AllocNonPagedPage (DWORD eip, DWORD cs, PVOID this_proc, PVOID *page, PHYSICAL_ADDRESS *phys, DWORD param3, DWORD esp, DWORD ss) {
	*page = ExAllocatePool(0, 4096);
	(*phys).QuadPart = MmGetPhysicalAddress(*page).QuadPart;
	return TRUE;
}

DWORD __cdecl FreeNonPagedPage (DWORD eip, DWORD cs, PVOID this_proc, PVOID page, DWORD param2, DWORD param3, DWORD esp, DWORD ss) {
	ExFreePool(page);
	return TRUE;
}

DWORD __cdecl IsProcessIdInJob (DWORD eip, DWORD cs, PVOID this_proc, DWORD process_id, DWORD extra, DWORD param3, DWORD esp, DWORD ss) {
	PVOID p;
	NTSTATUS status;
	status = PsLookupProcessByProcessId(process_id, &p);
	if(NT_SUCCESS(status)) return *(PVOID *)((PBYTE)p + 0x218) ? TRUE : FALSE;
	return FALSE;
}

DWORD __cdecl SetIOPL (DWORD eip, DWORD cs, PVOID this_proc, DWORD iopl, DWORD param2, DWORD param3, DWORD esp, DWORD ss) {
	__asm {
		mov eax, iopl
		and eax, 3
		shl eax, 12
		pushfd
		and [esp], ~(3<<12)
		or  [esp], eax
		popfd
	}
	return 0;
}

DWORD __cdecl K_LinearToPhysical(DWORD eip, DWORD cs, PVOID this_proc, PVOID linear, DWORD param2, DWORD param3, DWORD esp, DWORD ss) {
	//This procedure needs to be at the SAME linear and physical address
	//paging will go bye bye for a while
	__asm {
		push ecx
		mov edx, linear
		
		cli
		mov eax, cr0
		and eax, 7fffffffh
		mov cr0, eax
		
		mov eax, cr3
		and eax, 0FFFFF000h    ;eax = page directory
		
		mov ecx, edx
		shr ecx, 20           
		and ecx, 0FFFFFFFCh    ;ecx = page directory offset
		mov ecx, [eax + ecx]   ;ecx = page directory entry
		
		mov eax, edx
		and eax, 003FFFFFh     ;eax = table bits or 4m base
		
		bt ecx, 7
		jnc kpages
		and ecx, 0FFC00000h
		or  eax, ecx
		jmp done
	kpages:
		and ecx, 0FFFFF000h
		shr eax, 10
		and eax, 0FFCh
		mov ecx, [eax + ecx]   ;ecx = page table entry
		mov eax, edx
		and eax, 0FFFh
		and ecx, 0FFFFF000h
		or  eax, ecx
	done:
		mov edx, cr0
		or  edx, 80000000h
		mov cr0, edx
		sti
		
		pop ecx
	}
}

PVOID __cdecl GetVirtualForPhysical (DWORD eip, DWORD cs, PVOID this_proc, DWORD physical_address, DWORD param2, DWORD param3, DWORD esp, DWORD ss) {
	PHYSICAL_ADDRESS phys;
	phys.QuadPart =  physical_address;
	return MmGetVirtualForPhysical(phys);
}

PVOID __cdecl GetIRQL (DWORD eip, DWORD cs, PVOID this_proc, DWORD param1, DWORD param2, DWORD param3, DWORD esp, DWORD ss) {
	return KeGetCurrentIrql();
}

DWORD __cdecl GetBIOSData (DWORD eip, DWORD cs, PVOID this_proc, PVOID dst, DWORD size, DWORD param3, DWORD esp, DWORD ss) {
	PVOID bios = (PVOID)0xFFD16400;
	DWORD copied;
	__try {
		memcpy(dst, bios, size);
		copied = size;
	} __except(EXCEPTION_EXECUTE_HANDLER) {
		copied = 0;
	}
	return copied;
}

__inline LARGE_INTEGER  __readmsr(int reg) {
	LARGE_INTEGER i;
	__asm {
		mov ecx, reg
		rdmsr
		mov i.LowPart, eax
		mov i.HighPart, edx
	}
	return i;
}

__inline void __writemsr(unsigned long reg, LARGE_INTEGER val) {
	__asm {
		mov ecx, reg
		mov eax, val.LowPart
		mov edx, val.HighPart
		wrmsr
	}
}

void __declspec(naked) SYSCALL_Entry() {
	__asm {
		mov esp, 00000030h
		mov fs,  sp
		mov esp, fs:[40h]
		mov esp, ss:[esp + 4]
		
		push SEG_SELECTOR(KGDT_R3_DATA, GLOBAL_DESC_TBL, RING_3) //return ss
		push edx                                                 //return esp
		sub  dword ptr ss:[esp], 4
		pushfd                                                   //return eflags
		or   dword ptr ss:[esp], 1<<9
		push SEG_SELECTOR(KGDT_R3_CODE, GLOBAL_DESC_TBL, RING_3) //return cs
		push  ecx                                                //return eip
		
		mov cx, 0038h
		mov fs, cx
		
		jmp MappedSize                                           //we rewrite this later to KiSystemService
	}
}

DWORD __cdecl Enable_SYSCALL (DWORD eip, DWORD cs, PVOID this_proc, DWORD entry, DWORD param2, DWORD param3, DWORD esp, DWORD ss) {
	INT_GATE_DESC desc;
	LARGE_INTEGER msr;
	ULONG affinity;
	STAR star;
	IDTR idtr;
	
	GetIDTR(&idtr);
	desc = ((PINT_GATE_DESC)idtr.base)[0x2e];
	
	star.eip     = entry;
	star.call_cs = SEG_SELECTOR(KGDT_R0_CODE, GLOBAL_DESC_TBL, RING_0);
	star.ret_cs  = SEG_SELECTOR(KGDT_R3_CODE, GLOBAL_DESC_TBL, RING_3);
	
	msr.QuadPart = __readmsr(0xC0000080).QuadPart | 0x1LL;
	__writemsr(0xC0000080, msr);
	__writemsr(0xC0000081, *(LARGE_INTEGER *)&star);
	
	return desc.addrlo | (desc.addrhi<<16);
}

PVOID __cdecl GetKModuleImageBase(PSTR module_name) {
	PRTL_PROCESS_MODULES modules;
	PVOID base;
	ULONG length, i;
	NTSTATUS status;
	status = _NtQuerySystemInformation(
		SystemModuleInformation, NULL, 0, &length);
	if(status != STATUS_INFO_LENGTH_MISMATCH) return NULL;
	
	modules = malloc(length);
	status = _NtQuerySystemInformation(
		SystemModuleInformation, modules, length, &length);
	
	if(NT_SUCCESS(status)) {
		for(i = 0; i < modules->NumberOfModules; i++) {
			if(stricmp(&modules->Modules[i].FullPathName[modules->Modules[i].OffsetToFileName], module_name) == 0) {
				base = modules->Modules[i].ImageBase;
				free(modules);
				return base;
			}
		}
	}
	
	free(modules);
	return NULL;
}

int main(int nargs, char **args) {
	DWORD_PTR cpuMask;
	DWORD entry;
	PVOID ntoskrnl, hal;
	struct CALL_GATE_DESC call_gate;
	PVOID page; PHYSICAL_ADDRESS phys;
	PVOID page_mapped;
	NTSTATUS status;
	HANDLE h;
	DWORD i, KiSystemService;
	ULONG page_size = 4096;
	unsigned char buffer[256];
	
	GetProcAddress(GetModuleHandle("ntdll.dll"), "NtQuerySystemInformation");
	__asm mov _NtQuerySystemInformation, eax
	
	ntoskrnl = GetKModuleImageBase("ntoskrnl.exe");
	printf("ntoskrnl.exe @ 0x%08X\n", ntoskrnl);
	
	hal = GetKModuleImageBase("hal.dll");
	printf("hal.dll @ 0x%08X\n", hal);
	
	fflush(stdout);
	
	cpuMask = SetThreadAffinityMask(GetCurrentThread(), 1);
		if(call_gate_init()) {
			call_gate_create_desc(&call_gate, Ring0Entry, R0_CODE_SEG, RING_3, RING0ENTRY_PARAMS);
			entry = call_gate_install(&call_gate);
			printf("entry = 0x%x\n", entry);
			if(entry) {
			  if(call_proc_in_ring0(entry, Resolve_KMODE_funcs, ntoskrnl, hal, 0)) {
				//Wee lets play in Ring 0
				
				printf("IRQL=%d\n", call_proc_in_ring0(entry, GetIRQL, 0, 0, 0));
				
				if(call_proc_in_ring0(entry, AllocNonPagedPage, &page, &phys, 0)) {
					printf("Allocated page @ 0x%08X, physical 0x%08x\n", page, phys.LowPart);
					
					page_mapped = phys.LowPart;
					status = NtMapViewOfSection(PhysicalMemorySection, (HANDLE) -1,
						&page_mapped, 0L, page_size,
						&phys, &page_size, ViewShare, 0, 
						PAGE_READWRITE);
						
					if(NT_SUCCESS(status)) {
						printf("mapped page to 0x%08X\n", page_mapped);
						//memcpy(page_mapped, K_LinearToPhysical, 4096);
						//printf("page=0x%08X\n", call_proc_in_ring0(entry, page_mapped, page, 0, 0));
						
						KiSystemService = call_proc_in_ring0(entry, Enable_SYSCALL, page, 0, 0);
						
						memcpy(page_mapped, SYSCALL_Entry, 0x100);
						*(PDWORD)((PBYTE)page_mapped + 0x31) = (DWORD)page + 0x100;
						*(PDWORD)((PBYTE)page_mapped + 0x100) = KiSystemService;
						
						printf("press key when done with SYSCALL\n");
						getchar();
						
						NtUnmapViewOfSection((HANDLE) -1, page_mapped);
					} else {
						printf("error mapping : 0x%08X\n", status);
					}
				}
				call_proc_in_ring0(entry, FreeNonPagedPage, page, 0, 0);
				
				printf("Current process %s in a job\n", 
					call_proc_in_ring0(entry, IsProcessIdInJob, GetCurrentProcessId(), 0, 0) ? "is" : "is not");
				
				h = CreateJobObject(NULL, NULL);
				AssignProcessToJobObject(h, GetCurrentProcess());
				
				printf("Current process %s in a job\n", 
					call_proc_in_ring0(entry, IsProcessIdInJob, GetCurrentProcessId(), 0, 0) ? "is" : "is not");

				//be careful os might clear this...
				call_proc_in_ring0(entry, SetIOPL, RING_3, 0, 0);
				__asm xor eax, eax
				__asm mov al, 09h
				__asm out 70h, al
				__asm in  al,  71h
				__asm mov i, eax
				printf("das year from da cmos %02d\n", i);
				
				//printf("0x400 is mapped to 0x%08X\n", call_proc_in_ring0(entry, GetVirtualForPhysical, 0x400, 0, 0));
				
				call_proc_in_ring0(entry, GetBIOSData, buffer, sizeof(buffer), 0);
				for(i = 0; i < 256; i+=8) {
					printf("%04X : %02X %02X %02X %02X | %02X %02X %02X %02X\n", i, buffer[i], buffer[i+1], buffer[i+2], buffer[i+3], buffer[i+4], buffer[i+5], buffer[i+6], buffer[i+7]);
				}
			  }
			  call_gate_remove(entry);
			}
			call_gate_free();
		}
	SetThreadAffinityMask(GetCurrentThread(), cpuMask);
}



